"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.buttonStyles = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styleConst = require("@cloudflare/style-const");

var _styleContainer = require("@cloudflare/style-container");

var _componentIcon = require("@cloudflare/component-icon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var borderRadius = '4px';

var standardColors = function standardColors(theme, state) {
  var _theme$colors$button$, _theme$colors$button$2, _theme$colors$button$3, _theme$colors$button$4, _theme$colors$button$5, _theme$colors$button$6, _theme$colors$button$7;

  var color = theme.colors.gray[9];
  return {
    default: (0, _styleConst.isDarkMode)() ? color : theme.colors.gray[1],
    success: color,
    warning: color,
    inverted: {
      danger: (_theme$colors$button$ = theme.colors.button.plainDestructive[state]) === null || _theme$colors$button$ === void 0 ? void 0 : _theme$colors$button$.text,
      primary: (_theme$colors$button$2 = theme.colors.button.plain[state]) === null || _theme$colors$button$2 === void 0 ? void 0 : _theme$colors$button$2.text
    },
    primary: ((_theme$colors$button$3 = theme.colors.button.primary[state]) === null || _theme$colors$button$3 === void 0 ? void 0 : _theme$colors$button$3.text) || color,
    danger: ((_theme$colors$button$4 = theme.colors.button.danger[state]) === null || _theme$colors$button$4 === void 0 ? void 0 : _theme$colors$button$4.text) || color,
    plain: ((_theme$colors$button$5 = theme.colors.button.plain[state]) === null || _theme$colors$button$5 === void 0 ? void 0 : _theme$colors$button$5.text) || color,
    plainMono: ((_theme$colors$button$6 = theme.colors.button.plainMono[state]) === null || _theme$colors$button$6 === void 0 ? void 0 : _theme$colors$button$6.text) || color,
    plainDestructive: ((_theme$colors$button$7 = theme.colors.button.plainDestructive[state]) === null || _theme$colors$button$7 === void 0 ? void 0 : _theme$colors$button$7.text) || color
  };
};

var buttonColors = function buttonColors(theme) {
  var standardIndex = (0, _styleConst.isDarkMode)() ? 3 : 4;
  var hoverIndex = (0, _styleConst.isDarkMode)() ? 1 : 2;
  return {
    // Normal default state colors
    normal: {
      backgroundColor: {
        default: (0, _styleConst.isDarkMode)() ? theme.colors.gray[standardIndex] : theme.colors.gray[8],
        primary: theme.colors.button.primary.normal.background,
        success: theme.colors.green[standardIndex],
        warning: theme.colors.orange[standardIndex],
        danger: theme.colors.button.danger.normal.background,
        inverted: {
          danger: theme.colors.button.plainDestructive.normal.background,
          primary: theme.colors.button.plain.normal.background
        },
        plain: 'transparent',
        plainMono: 'transparent',
        plainDestructive: 'transparent'
      },
      color: standardColors(theme, 'normal')
    },
    // Hover
    hover: {
      backgroundColor: {
        default: theme.colors.gray[(0, _styleConst.isDarkMode)() ? 2 : 7],
        primary: theme.colors.button.primary.hover.background,
        success: theme.colors.green[hoverIndex],
        warning: theme.colors.orange[hoverIndex],
        danger: theme.colors.button.danger.hover.background,
        inverted: {
          danger: theme.colors.button.plainDestructive.hover.background,
          primary: theme.colors.button.plain.hover.background
        },
        plain: theme.colors.button.plain.hover.background,
        plainMono: theme.colors.button.plainMono.hover.background,
        plainDestructive: theme.colors.button.plainDestructive.hover.background
      },
      color: standardColors(theme, 'hover')
    },
    // Active
    active: {
      backgroundColor: {
        default: theme.colors.gray[(0, _styleConst.isDarkMode)() ? 3 : 6],
        primary: theme.colors.button.primary.active.background,
        success: theme.colors.green[standardIndex],
        warning: theme.colors.orange[standardIndex],
        danger: theme.colors.button.danger.active.background,
        inverted: {
          danger: theme.colors.button.plainDestructive.active.background,
          primary: theme.colors.button.plain.active.background
        },
        plain: theme.colors.button.plain.active.background,
        plainMono: theme.colors.button.plainMono.active.background,
        plainDestructive: theme.colors.button.plainDestructive.active.background
      },
      color: standardColors(theme, 'active')
    },
    // Focus
    focus: {
      backgroundColor: {
        default: theme.colors.gray[(0, _styleConst.isDarkMode)() ? 2 : 7],
        primary: theme.colors.button.primary.focus.background,
        success: theme.colors.green[standardIndex],
        warning: theme.colors.orange[standardIndex],
        danger: theme.colors.button.danger.focus.background,
        inverted: {
          danger: theme.colors.button.plainDestructive.focus.background,
          primary: theme.colors.button.plain.focus.background
        },
        plain: theme.colors.button.plain.focus.background,
        plainMono: theme.colors.button.plainMono.focus.background,
        plainDestructive: theme.colors.button.plainDestructive.focus.background
      },
      color: standardColors(theme, 'focus')
    }
  };
};

var colorAccessor = function colorAccessor(property, _ref) {
  var _ref$inverted = _ref.inverted,
      inverted = _ref$inverted === void 0 ? false : _ref$inverted,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'default' : _ref$type;
  return !property ? undefined : inverted && (type === 'danger' || type === 'primary') ? property.inverted[type] : property[type];
};

var interactionStyleAccessor = function interactionStyleAccessor(interactionState, props) {
  var theme = props.theme,
      loading = props.loading,
      disabled = props.disabled;
  var isInteractive = !(loading || disabled);
  var stateStyles = buttonColors(theme)[interactionState];
  var color = colorAccessor(stateStyles.color, props);
  var backgroundColor = colorAccessor(stateStyles.backgroundColor, props);
  return isInteractive ? {
    backgroundColor: backgroundColor,
    color: color,
    boxShadow: props.inverted ? "inset 0px 0px 0px 1px ".concat(color) : undefined
  } : undefined;
};

var buttonStyles = function buttonStyles(props) {
  var _styles$buttonState, _styles$buttonState2;

  var theme = props.theme,
      _props$loading = props.loading,
      loading = _props$loading === void 0 ? false : _props$loading,
      disabled = props.disabled,
      direction = props.direction,
      group = props.group,
      spaced = props.spaced,
      _props$space = props.space,
      space = _props$space === void 0 ? 2 : _props$space,
      _props$type = props.type,
      type = _props$type === void 0 ? 'default' : _props$type,
      stretch = props.stretch,
      noWrapText = props.noWrapText,
      buttonState = props.buttonState,
      compact = props.compact;
  var styles = {
    normal: buttonColors(theme).normal,
    hover: interactionStyleAccessor('hover', props),
    active: interactionStyleAccessor('active', props),
    focus: interactionStyleAccessor('focus', props)
  };
  var color = buttonState && styles[buttonState] ? (_styles$buttonState = styles[buttonState]) === null || _styles$buttonState === void 0 ? void 0 : _styles$buttonState.color : colorAccessor(styles.normal.color, props);
  var backgroundColor = buttonState && styles[buttonState] ? (_styles$buttonState2 = styles[buttonState]) === null || _styles$buttonState2 === void 0 ? void 0 : _styles$buttonState2.backgroundColor : colorAccessor(styles.normal.backgroundColor, props);
  return _objectSpread(_objectSpread(_objectSpread({}, buttonState ? {} : {
    '&:focus': styles.focus,
    '&:hover': styles.hover,
    '&:active': styles.active,
    '&:focus:active': styles.active
  }), {}, {
    '&:focus-visible': {
      outlineOffset: 2,
      outlineWidth: 2,
      outlineStyle: 'solid',
      outlineColor: type === 'danger' || type === 'plainDestructive' ? theme.colors.red[(0, _styleConst.isDarkMode)() ? 3 : 4] : theme.colors.focus
    },
    '&[title]': {
      pointerEvents: disabled ? 'auto' : 'none'
    },
    backgroundColor: backgroundColor,
    color: loading ? 'transparent' : color,
    cursor: disabled || loading ? 'default' : 'pointer',
    display: 'inline-flex',
    gap: 1,
    flexGrow: stretch ? 1 : undefined,
    alignItems: 'center',
    justifyContent: 'center',
    fontFamily: theme.fontFamily,
    fontSize: compact ? 1 : 2,
    fontWeight: 500,
    lineHeight: 1.2,
    border: 'none'
  }, props.inverted ? {
    boxShadow: "inset 0px 0px 0px 1px ".concat(color)
  } : {}), {}, {
    borderTopRightRadius: (group === 'first' || group === 'inbetween') && !spaced ? 0 : borderRadius,
    borderTopLeftRadius: (group === 'last' || group === 'inbetween') && !spaced ? 0 : borderRadius,
    borderBottomLeftRadius: (group === 'last' || group === 'inbetween') && !spaced ? 0 : borderRadius,
    borderBottomRightRadius: (group === 'first' || group === 'inbetween') && !spaced ? 0 : borderRadius,
    '&::before': loading ? {
      content: '"•••"',
      color: color,
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center',
      position: 'absolute',
      left: 0,
      height: '100%',
      width: '100%',
      opacity: 1,
      animationName: {
        '50%': {
          opacity: 0
        }
      },
      animationDuration: '1s',
      animationIterationCount: 'infinite',
      animationTimingFunction: 'linear'
    } : {
      display: 'none'
    },
    opacity: disabled ? 0.5 : 'inherit',
    mt: spaced && direction === 'column' && group !== 'first' ? space : 0,
    mr: 0,
    mb: 0,
    ml: spaced && direction === 'row' && group !== 'first' ? space : 0,
    px: compact ? '11px' : 3,
    py: compact ? 1 : 2,
    pointerEvents: disabled ? 'none' : 'auto',
    position: 'relative',
    textAlign: 'center',
    transitionProperty: 'all',
    transitionDuration: '300ms',
    transitionTimingFunction: 'ease',
    userSelect: 'none',
    maxWidth: 'initial',
    float: 'none',
    whiteSpace: noWrapText ? 'nowrap' : 'normal',
    width: direction === 'column' ? '100%' : 'auto'
  });
};

exports.buttonStyles = buttonStyles;

var Button = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var id = props.id,
      name = props.name,
      _props$submit = props.submit,
      submit = _props$submit === void 0 ? false : _props$submit,
      className = props.className,
      disabled = props.disabled,
      _props$loading2 = props.loading,
      loading = _props$loading2 === void 0 ? false : _props$loading2,
      testId = props.testId,
      children = props.children,
      onClick = props.onClick,
      iconType = props.iconType,
      iconLabel = props.iconLabel,
      iconProps = props.iconProps,
      iconSize = props.iconSize,
      _props$iconPosition = props.iconPosition,
      iconPosition = _props$iconPosition === void 0 ? 'left' : _props$iconPosition,
      form = props.form,
      tabIndex = props.tabIndex,
      ariaLabel = props.ariaLabel;
  var ariaAndDataProps = Object.keys(props).filter(function (propName) {
    return propName.startsWith('data-') || _styleContainer.ariaAttributes.includes(propName);
  }).reduce(function (memo, propName) {
    return _objectSpread(_objectSpread({}, memo), {}, _defineProperty({}, propName, props[propName]));
  }, {});
  return /*#__PURE__*/_react.default.createElement("button", _extends({}, ariaAndDataProps, {
    id: id,
    name: name,
    type: submit ? 'submit' : 'button',
    "data-testid": testId,
    disabled: disabled || loading,
    className: className,
    onClick: onClick,
    form: form,
    tabIndex: tabIndex,
    ref: ref,
    "aria-label": ariaLabel
  }), iconType && iconPosition === 'left' && /*#__PURE__*/_react.default.createElement(_componentIcon.Icon, _extends({
    size: iconSize,
    type: iconType,
    ariaLabel: iconLabel
  }, iconProps)), children, iconType && iconPosition === 'right' && /*#__PURE__*/_react.default.createElement(_componentIcon.Icon, _extends({
    size: iconSize,
    type: iconType,
    ariaLabel: iconLabel
  }, iconProps)));
});

Button.propTypes = {
  id: _propTypes.default.string,
  name: _propTypes.default.string,
  onClick: _propTypes.default.func,
  submit: _propTypes.default.bool,
  spaced: _propTypes.default.bool,
  space: _propTypes.default.number,
  direction: _propTypes.default.oneOf(['column', 'row']),
  className: _propTypes.default.string,
  group: _propTypes.default.oneOf(['first', 'inbetween', 'last']),
  type: _propTypes.default.oneOf(['default', 'primary', 'success', 'warning', 'danger', 'plain', 'plainMono', 'plainDestructive']),
  testId: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  inverted: _propTypes.default.bool,
  iconType: _propTypes.default.string,
  iconLabel: _propTypes.default.string,
  iconSize: _propTypes.default.number,
  form: _propTypes.default.string,
  tabIndex: _propTypes.default.number,
  ariaLabel: _propTypes.default.string,
  stretch: _propTypes.default.bool,
  noWrapText: _propTypes.default.bool,
  buttonState: _propTypes.default.oneOf(['hover', 'active', 'focus']),
  compact: _propTypes.default.bool
};
Button.displayName = 'Button';

var _default = (0, _styleContainer.createStyledComponent)(buttonStyles, Button);

exports.default = _default;